using System ;
using System.Collections.Generic ;
using System.ComponentModel ;
using System.Data ;
using System.Drawing ;
using System.Linq ;
using System.Text ;
using System.Windows.Forms ;
using System.IO ;
using System.Diagnostics ;
using System.Xml.Serialization ;

namespace SanwaNewtec.Demonstrate.SampleRWControlCS.Datas
{
  using SanwaNewtec.DeviceControls ;
  using Common; 

  ///===================================================================================================
  /// <summary>
  /// sDʐMݒp[^NXt
  /// ύX
  ///   2006/10/27 ( kw ) 
  /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
  /// </summary>
  public class CommPort: ICloneable
  {
    public const string _strParityNone= "Ȃ" ;
    public const string _strParityEven= "" ;
    public const string _strParityOdd = "" ;
    public const string _strStopBitsOne= "1" ;
    public const string _strStopBitsTwo= "2" ;
    //
    string _portName= "" ;
    V31SerialControl.BAUDRATE _baudRate= V31SerialControl._defBaudRate ;
    V31SerialControl.PARITY   _parity  = V31SerialControl._defParity ;
    V31SerialControl.STOPBITS _stopBits= V31SerialControl._defStopBits ;
    int _timeout= 5000 ;
    int _retryTime= 100 ;
    
    public string                     PortName { get { return _portName ; } set { _portName = value ; } }
    public V31SerialControl.BAUDRATE  BaudRate { get { return _baudRate ; } set { _baudRate = value ; } }
    public V31SerialControl.PARITY    Parity   { get { return _parity   ; } set { _parity   = value ; } }
    public V31SerialControl.STOPBITS  StopBits { get { return _stopBits ; } set { _stopBits = value ; } }
    public int                 Timeout  { get { return _timeout  ; } set { _timeout  = value ; } }
    public int                 RetryTime{ get { return _retryTime; } set { _retryTime= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// ʐMݒp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
    /// </summary>
    /// <param name="cbPortName"></param>
    /// <param name="cbBaudRate"></param>
    /// <param name="cbParity"></param>
    /// <param name="cbStopBits"></param>
    /// <param name="nuTimeout"></param>
    /// <param name="nuRetryTime"></param>
    public static void SetControls(ComboBox cbPortName, ComboBox cbBaudRate, ComboBox cbParity, ComboBox cbStopBits, NumericUpDown nuTimeout, NumericUpDown nuRetryTime)
    {
      cbPortName.Items.AddRange( V31SerialControl.GetPortNames() ) ;
      cbBaudRate.Items.AddRange(new object[]{1200, 2400, 4800, 9600, 19200, 38400 } ) ;
      cbParity  .Items.AddRange(new object[]{_strParityNone , _strParityEven, _strParityOdd } ) ;
      cbStopBits.Items.AddRange(new object[]{_strStopBitsOne, _strStopBitsTwo } ) ;
      nuTimeout.Maximum  = V31Control._maxTimeout ;
      nuTimeout.Minimum  = V31Control._minTimeout ;
      nuRetryTime.Maximum= V31Control._maxRetryTime ;
      nuRetryTime.Minimum= V31Control._minRetryTime ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// yDftHgRXgN^z
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
    /// </summary>
    public CommPort()
    {
      string[] ports= V31SerialControl.GetPortNames() ;
      if(ports.Length!= 0 ){
        _portName= ports[0] ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʐMݒp[^̕\Ԃ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("PortName={0},BaudRate={1},Parity={2},StopBits={3},TimeOut={4},RetryTime={5}", _portName, _baudRate, _parity, _stopBits, _timeout, _retryTime ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʐMݒp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      ///
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is CommPort ){
          CommPort r= (CommPort)obj ;
          rc= (r._portName == _portName  )
            &&(r._baudRate == _baudRate  )
            &&(r._parity   == _parity    )
            &&(r._stopBits == _stopBits  )
            &&(r._timeout  == _timeout   )
            &&(r._retryTime== _retryTime ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʐMݒp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      CommPort r= new CommPort() ;
      r._portName  = _portName ;
      r._baudRate  = _baudRate ;
      r._parity    = _parity   ;
      r._stopBits  = _stopBits ;
      r._timeout   = _timeout  ;
      r._retryTime = _retryTime;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʐMݒp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
    /// </summary>
    /// <param name="cbPortName"></param>
    /// <param name="cbBaudRate"></param>
    /// <param name="cbParity"></param>
    /// <param name="cbStopBits"></param>
    /// <param name="nuTimeout"></param>
    /// <param name="nuRetryTime"></param>
    public void Export(ComboBox cbPortName, ComboBox cbBaudRate, ComboBox cbParity, ComboBox cbStopBits, NumericUpDown nuTimeout, NumericUpDown nuRetryTime)
    {
      cbPortName.Text= _portName ; 
      cbBaudRate.Text= ((int)_baudRate ).ToString() ;
      switch( _parity ){
      case V31SerialControl.PARITY.NO  : cbParity.Text= _strParityNone ; break ;
      case V31SerialControl.PARITY.EVEN: cbParity.Text= _strParityEven ; break ;
      case V31SerialControl.PARITY.ODD : cbParity.Text= _strParityOdd  ; break ;
      }
      switch( _stopBits ){
      case V31SerialControl.STOPBITS.ONE: cbStopBits.Text= _strStopBitsOne; break ;
      case V31SerialControl.STOPBITS.TWO: cbStopBits.Text= _strStopBitsTwo; break ;
      }
      nuTimeout  .Value= _timeout ;
      nuRetryTime.Value= _retryTime ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒʐMݒp[^̃f[^oɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
    /// </summary>
    /// <param name="cbPortName"></param>
    /// <param name="cbBaudRate"></param>
    /// <param name="cbParity"></param>
    /// <param name="cbStopBits"></param>
    /// <param name="nuTimeout"></param>
    /// <param name="nuRetryTime"></param>
    public void Import(ComboBox cbPortName, ComboBox cbBaudRate, ComboBox cbParity, ComboBox cbStopBits, NumericUpDown nuTimeout, NumericUpDown nuRetryTime)
    {
      _portName= cbPortName.Text ; // |[g
      _baudRate= (V31SerialControl.BAUDRATE)int.Parse(cbBaudRate.Text ) ;
      switch( cbParity.Text ){
      case _strParityNone: _parity= V31SerialControl.PARITY.NO  ; break ;
      case _strParityEven: _parity= V31SerialControl.PARITY.EVEN; break ;
      case _strParityOdd : _parity= V31SerialControl.PARITY.ODD ; break ;
      }
      switch( cbStopBits.Text ){
      case _strStopBitsOne: _stopBits= V31SerialControl.STOPBITS.ONE ; break ;
      case _strStopBitsTwo: _stopBits= V31SerialControl.STOPBITS.TWO ; break ;
      }
      _timeout  = (int)nuTimeout  .Value ;
      _retryTime= (int)nuRetryTime.Value ;
    }
  }

  # region InitialR}hp[^
  ///===================================================================================================
  /// <summary>
  /// sDCjVR}hp[^NXt
  /// ύX
  ///   2006/10/27 ( kw ) 


  /// </summary>
  public class Initialize: ICloneable
  {
    const string _strIniMode30= "CjV̂" ;
    const string _strIniMode31= "CjV{J[hro" ;
    const string _strIniMode32= "Zbgw" ;
    const string _strRspMode30= "݊P[h" ;
    const string _strRspMode31= "݊Q[h" ;
    const string _strRspMode32= "V31[h" ;

    byte _iniMode= 0x30 ;
    byte _rspMode= 0x30 ;
    public byte IniMode { get { return _iniMode ; } set { _iniMode= value ; } } 
    public byte RspMode { get { return _rspMode ; } set { _rspMode= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="cbIniMode"></param>
    /// <param name="cbRspMode"></param>
    public static void SetControls(ComboBox cbIniMode, ComboBox cbRspMode)
    {
      cbIniMode.Items.AddRange(new object[]{ _strIniMode30, _strIniMode31, _strIniMode32 } ) ;
      cbRspMode.Items.AddRange(new object[]{ _strRspMode30, _strRspMode31, _strRspMode32 } ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hp[^̕\Ԃ 
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Mode=0x{0:X2},RspMode=0x{1:X2}", _iniMode, _rspMode ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is Initialize  ){
          Initialize r= (Initialize)obj ;
          rc= (r._iniMode== _iniMode )
            &&(r._rspMode== _rspMode ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      Initialize r= new Initialize() ;
      r._iniMode= _iniMode ;
      r._rspMode= _rspMode ;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CjVR}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="cbIniMode"></param>
    /// <param name="cbRspMode"></param>
    public void Export(ComboBox cbIniMode, ComboBox cbRspMode)
    {
      switch( _iniMode ){
      case 0x30: cbIniMode.Text= _strIniMode30 ; break ;
      case 0x31: cbIniMode.Text= _strIniMode31 ; break ;
      case 0x32: cbIniMode.Text= _strIniMode32 ; break ;
      }
      switch( _rspMode ){
      case 0x30: cbRspMode.Text= _strRspMode30 ; break ;
      case 0x31: cbRspMode.Text= _strRspMode31 ; break ;
      case 0x32: cbRspMode.Text= _strRspMode32 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒCjVR}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="cbIniMode"></param>
    /// <param name="cbRspMode"></param>
    public void Import(ComboBox cbIniMode, ComboBox cbRspMode)
    {
      switch( cbIniMode.Text ){
      case _strIniMode30: _iniMode= 0x30 ; break ;
      case _strIniMode31: _iniMode= 0x31 ; break ;
      case _strIniMode32: _iniMode= 0x32 ; break ;
      }
      switch( cbRspMode.Text ){
      case _strRspMode30: _rspMode= 0x30; break ;
      case _strRspMode31: _rspMode= 0x31; break ;
      case _strRspMode32: _rspMode= 0x32; break ;
      }
    }
  }
  # endregion

  # region [hR}hp[^
  ///===================================================================================================
  /// <summary>
  /// sD[hR}hp[^NXt
  /// ύX
  ///   2006/10/27 ( kw ) 
  ///   2013/06/20  (k.kondo)  [_strMode34 = "tϒi1`69oCgj[h"]ǉ
  /// </summary>
  public class Read: ICloneable
  {
    const string _strMode30= "Wi69oCgj[h";
    const string _strMode31= "CRA-2200݊[h";
    const string _strMode32= "J[h荞";
    const string _strMode33= "ϒi1`69oCgj[h";
    const string _strMode34= "tϒi1`69oCgj[h";
    const string _strCheck30= "peB";
    const string _strCheck31= "peBȂ";
    const string _strTrack30= "gbNP̃[hw";
    const string _strTrack31= "gbNQ̃[hw";
    const string _strTrack32= "gbNR̃[hw";
    const string _strTrack33= "gbNPCQ̃[hw";
    const string _strTrack34= "gbNPCR̃[hw";
    const string _strTrack35= "gbNQCR̃[hw";
    const string _strTrack36= "gbNPCQCRSẴ[hw";
    const byte _defCheck= 0x31 ; // peBȂ
    const byte _defTrack= 0x36 ; // gbN1-3[h

    byte _mode= 0x30 ;
    byte _check= _defCheck ;
    byte _track= _defTrack ;
    
    public byte Mode { get { return _mode  ; } set { _mode = value ; } }
    public byte Check{ get { return _check ; } set { _check= value ; } }
    public byte Track{ get { return _track ; } set { _track= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2013/06/20  (k.kondo)  cbReadModep[^_strMode34ǉ
    /// </summary>
    /// <param name="cbReadMode"></param>
    /// <param name="cbReadCheck"></param>
    /// <param name="cbReadTrack"></param>
    public static void SetControls(ComboBox cbReadMode, ComboBox cbReadCheck, ComboBox cbReadTrack)
    {
      cbReadMode.Items.AddRange(new object[]{ _strMode30, _strMode31, _strMode32, _strMode33, _strMode34 } ) ;
      cbReadCheck.Items.AddRange(new object[]{ _strCheck30, _strCheck31 } ) ;
      cbReadTrack.Items.AddRange(new object[]{ _strTrack30, _strTrack31, _strTrack32, _strTrack33, _strTrack34, _strTrack35, _strTrack36 } ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Mode=0x{0:X2},Check=0x{1:X2},Track=0x{2:X2}", _mode, _check, _track ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///****************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is Read ){
          Read r= (Read)obj ;
          rc= (r._mode == _mode  )
            &&(r._check== _check )
            &&(r._track== _track ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hp[^̃Rs[CX^XԂ
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      Read r= new Read() ;
      r._mode = _mode  ; 
      r._check= _check ;
      r._track= _track ;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// [hR}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2013/06/20  (k.kondo)  [34h tϒi1`69oCgj[h]ǉ
    /// </summary>
    /// <param name="cbReadMode"></param>
    /// <param name="cbReadCheck"></param>
    /// <param name="cbReadTrack"></param>
    public void Export(ComboBox cbReadMode, ComboBox cbReadCheck, ComboBox cbReadTrack)
    {
      switch( _mode ){
      case 0x30: cbReadMode.Text= _strMode30 ; break ;
      case 0x31: cbReadMode.Text= _strMode31 ; break ;
      case 0x32: cbReadMode.Text= _strMode32 ; break ;
      case 0x33: cbReadMode.Text= _strMode33 ; break ;
      case 0x34: cbReadMode.Text= _strMode34 ; break ;
      }
      switch( _check ){
      case 0x30: cbReadCheck.Text= _strCheck30 ; break ;
      case 0x31: cbReadCheck.Text= _strCheck31 ; break ;
      }
      switch( _track ){
      case 0x30: cbReadTrack.Text= _strTrack30 ; break ;
      case 0x31: cbReadTrack.Text= _strTrack31 ; break ;
      case 0x32: cbReadTrack.Text= _strTrack32 ; break ;
      case 0x33: cbReadTrack.Text= _strTrack33 ; break ;
      case 0x34: cbReadTrack.Text= _strTrack34 ; break ;
      case 0x35: cbReadTrack.Text= _strTrack35 ; break ;
      case 0x36: cbReadTrack.Text= _strTrack36 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒ[hR}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2013/06/20  (k.kondo)  [34h tϒi1`69oCgj[h]ǉ
    /// </summary>
    /// <param name="cbReadMode"></param>
    /// <param name="cbReadCheck"></param>
    /// <param name="cbReadTrack"></param>
    public void Import(ComboBox cbReadMode, ComboBox cbReadCheck, ComboBox cbReadTrack)
    {
      switch( cbReadMode.Text ){
      case _strMode30: _mode= 0x30 ; break ;
      case _strMode31: _mode= 0x31 ; break ;
      case _strMode32: _mode= 0x32 ; break ;
      case _strMode33: _mode= 0x33 ; break ;
      case _strMode34: _mode= 0x34 ; break ;
      }
      switch( cbReadCheck.Text ){
      case _strCheck30: _check= 0x30 ; break ;
      case _strCheck31: _check= 0x31 ; break ;
      }
      switch( cbReadTrack.Text ){
      case _strTrack30: _track= 0x30 ; break ;
      case _strTrack31: _track= 0x31 ; break ;
      case _strTrack32: _track= 0x32 ; break ;
      case _strTrack33: _track= 0x33 ; break ;
      case _strTrack34: _track= 0x34 ; break ;
      case _strTrack35: _track= 0x35 ; break ;
      case _strTrack36: _track= 0x36 ; break ;
      }
    }
  }
  # endregion

  # region CgR}hp[^
  ///===================================================================================================
  /// <summary>
  /// sDCgR}hp[^NXt
  /// ύX
  ///   2006/10/27 ( kw ) 
  ///   2006/11/10 ( kw ) Cgf[^t@C̃f[^oǉ
  ///   2013/06/20  (k.kondo)  [_strMode34 = "tϒi1`69oCgjCg"]ǉ
  /// </summary>
  public class Write: ICloneable
  {
    const string _strMode30= "Wi69oCgjCg" ;
    const string _strMode31= "CRA-2200݊Cg" ;
    const string _strMode33= "ϒi1`69oCgjCg" ;
    const string _strMode34= "tϒi1`69oCgjCg" ;
    const string _strCheck30= "peB" ;
    const string _strCheck31= "peBȂ" ;
    const string _strTrack30= "gbNP̃Cgw" ;
    const string _strTrack31= "gbNQ̃Cgw" ;
    const string _strTrack32= "gbNR̃Cgw" ;
    const string _strTrack33= "gbNPCQ̃Cgw" ;
    const string _strTrack34= "gbNPCR̃Cgw" ;
    const string _strTrack35= "gbNQCR̃Cgw" ;
    const string _strTrack36= "gbNPCQCRSẴCgw" ;
    const string _defFileName= "Write.xml" ;
    const byte _defCheck= 0x31 ; // peBȂ
    const byte _defTrack= 0x36 ; // gbN1`3SẴCg

    byte _mode= 0x30 ;
    byte _check= _defCheck ;
    byte _track= _defTrack ;
    string _fileName= _defFileName ;

    public byte   Mode    { get { return _mode     ; } set { _mode    = value ; } }
    public byte   Check   { get { return _check    ; } set { _check   = value ; } }
    public byte   Track   { get { return _track    ; } set { _track   = value ; } }
    public string FileName{ get { return _fileName ; } set { _fileName= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2013/06/20  (k.kondo)  cbWriteModep[^_strMode34ǉ
    /// </summary>
    /// <param name="cbWriteMode"></param>
    /// <param name="cbWriteCheck"></param>
    /// <param name="cbWriteTrack"></param>
    public static void SetControls(ComboBox cbWriteMode, ComboBox cbWriteCheck, ComboBox cbWriteTrack)
    {
      cbWriteMode .Items.AddRange(new object[]{ _strMode30, _strMode31, _strMode33, _strMode34 } ) ;
      cbWriteCheck.Items.AddRange(new object[]{ _strCheck30, _strCheck31 } ) ;
      cbWriteTrack.Items.AddRange(new object[]{ _strTrack30, _strTrack31, _strTrack32, _strTrack33, _strTrack34, _strTrack35, _strTrack36 } ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Mode=0x{0:X2},Check=0x{1:X2},Track=0x{2:X2}", _mode, _check, _track ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode() ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// IuWFNg̔rs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is Write ){
          Write r= (Write)obj ;
          rc= (r._mode    == _mode     )
            &&(r._check   == _check    )
            &&(r._track   == _track    )
            &&(r._fileName== _fileName ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      Write rc= new Write() ;
      rc._mode    = _mode    ;
      rc._check   = _check   ;
      rc._track   = _track   ;
      rc._fileName= _fileName;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// CgR}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2013/06/20  (k.kondo)  [34h tϒi1`69oCgjCg]ǉ
    /// </summary>
    /// <param name="cbWriteMode"></param>
    /// <param name="cbWriteCheck"></param>
    /// <param name="cbWriteTrack"></param>
    public void Export(ComboBox cbWriteMode, ComboBox cbWriteCheck, ComboBox cbWriteTrack)
    {
      switch( _mode ){
      case 0x30: cbWriteMode.Text= _strMode30 ; break ;
      case 0x31: cbWriteMode.Text= _strMode31 ; break ;
      case 0x33: cbWriteMode.Text= _strMode33 ; break ;
      case 0x34: cbWriteMode.Text= _strMode34 ; break ;
      }
      switch( _check ){
      case 0x30: cbWriteCheck.Text= _strCheck30 ; break ;
      case 0x31: cbWriteCheck.Text= _strCheck31 ; break ;
      }
      switch( _track ){
      case 0x30: cbWriteTrack.Text= _strTrack30 ; break ;
      case 0x31: cbWriteTrack.Text= _strTrack31 ; break ;
      case 0x32: cbWriteTrack.Text= _strTrack32 ; break ;
      case 0x33: cbWriteTrack.Text= _strTrack33 ; break ;
      case 0x34: cbWriteTrack.Text= _strTrack34 ; break ;
      case 0x35: cbWriteTrack.Text= _strTrack35 ; break ;
      case 0x36: cbWriteTrack.Text= _strTrack36 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒCgR}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    ///   2013/06/20  (k.kondo)  [34h tϒi1`69oCgjCg]ǉ
    /// </summary>
    /// <param name="cbWriteMode"></param>
    /// <param name="cbWriteCheck"></param>
    /// <param name="cbWriteTrack"></param>
    public void Import(ComboBox cbWriteMode, ComboBox cbWriteCheck, ComboBox cbWriteTrack)
    {
      switch(cbWriteMode.Text ){
      case _strMode30: _mode= 0x30 ; break ;
      case _strMode31: _mode= 0x31 ; break ;
      case _strMode33: _mode= 0x33 ; break ;
      case _strMode34: _mode= 0x34 ; break ;
      }
      switch( cbWriteCheck.Text ){
      case _strCheck30: _check= 0x30 ; break ;
      case _strCheck31: _check= 0x31 ; break ;
      }
      switch( cbWriteTrack.Text ){
      case _strTrack30: _track= 0x30 ; break ;
      case _strTrack31: _track= 0x31 ; break ;
      case _strTrack32: _track= 0x32 ; break ;
      case _strTrack33: _track= 0x33 ; break ;
      case _strTrack34: _track= 0x34 ; break ;
      case _strTrack35: _track= 0x35 ; break ;
      case _strTrack36: _track= 0x36 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Cgf[^ƂĕKvȃoCgԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/09/02 ( kw ) ϒf[^ɍ킹ăf[^쐬ł悤ɂ
    ///   2013/06/20  (k.kondo)  [34h tϒi1`69oCgjCgɑΉ
    ///                          ܂A33h(ϒ)w莞AgbNQΉłlɕύX
    /// </summary>
    /// <returns></returns>
    public int GetNecessaryBytes(int datalen )
    {
      int rc= 0 ; // return code of this proc
      switch( _mode ){
      // Wi69oCgj
      case 0x30:
        if(     ComDef.IsBw(_track, 0x30, 0x32 ) ) rc= 69* 1 ;
        else if(ComDef.IsBw(_track, 0x33, 0x35 ) ) rc= 69* 2 ;
        else {
          rc= 69* 3 ;
        }
        break ;
      // CRA-2200݊
      case 0x31:
        if(_track== 0x30 ){
          if(datalen< 47 ) rc= datalen ;
          else {
            rc= 47 ; 
          }
        }
        break ;
      // ϒi1`69j
      case 0x33:
        if((_track== 0x30) || (_track == 0x31) ){
          if(datalen< 69 ) rc= datalen ;
          else {
            rc= 69 ; 
          }
        }
        break ;
      //tϒi1`69j
      case 0x34:
        if(_track == 0x31){
          if(datalen < 69){
            rc = datalen;
          }
          else{
            rc = 69;
          }
        }
        break;
      default:
        break;
      }
      return rc ;
    }
  }
  # endregion

  # region Oo^R}hp[^
  ///===================================================================================================
  /// <summary>
  /// sDOo^R}hp[^NXt
  /// ύX
  ///   2006/10/26 ( kw ) 
  ///   2006/11/10 ( kw ) Oo^f[^t@Cpf[^oǉ
  /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
  /// </summary>
  public class RegisterGaiji: ICloneable
  {
    const string _strSize30= "Sp24~24hbg" ;
    const string _strSize31= "Sp16~16hbg" ;
    const string _strSize32= "p12~24hbg" ;
    const string _strSize33= "p 8~16hbg" ;
    const byte _maxNo= 0xFF ;
    const byte _minNo= 0x01 ;
    const string _defFileName= "RegisterGaiji.dat" ; 
    //
    byte _no= _minNo ;
    byte _size= 0x30 ;
    string _fileName= _defFileName ;
    //
    public const short _maxWidth = 24 ;
    public const short _maxHeight= 24 ;
    //
    public byte   No      { get { return _no      ; } set { _no      = value ; } }
    public byte   Size    { get { return _size    ; } set { _size    = value ; } }
    public string FileName{ get { return _fileName; } set { _fileName= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="nuGaijiNo"></param>
    /// <param name="cbGaijiSize"></param>
    public static void SetControls(NumericUpDown nuGaijiNo, ComboBox cbGaijiSize)
    {
      nuGaijiNo.Maximum= _maxNo ;
      nuGaijiNo.Minimum= _minNo ;
      cbGaijiSize.Items.AddRange(new object[]{ _strSize30, _strSize31, _strSize32, _strSize33 } ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("No={0:X2},Size={1:X2}", _no, _size ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode() ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is RegisterGaiji ){
          RegisterGaiji r= (RegisterGaiji)obj ;
          rc= (r._no      == _no       )
            &&(r._size    == _size     )
            &&(r._fileName== _fileName ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) t@Cf[^o]L̒ǋL
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      RegisterGaiji rc= new RegisterGaiji() ;
      rc._no      = _no      ;
      rc._size    = _size    ;
      rc._fileName= _fileName;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^R}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="nuGaijiNo"></param>
    /// <param name="cbGaijiSize"></param>
    public void Export(NumericUpDown nuGaijiNo, ComboBox cbGaijiSize)
    {
      nuGaijiNo.Value= _no ;
      switch( _size ){
      case 0x30: cbGaijiSize.Text= _strSize30 ; break ;
      case 0x31: cbGaijiSize.Text= _strSize31 ; break ;
      case 0x32: cbGaijiSize.Text= _strSize32 ; break ;
      case 0x33: cbGaijiSize.Text= _strSize33 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒOo^R}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="nuGaijiNo"></param>
    /// <param name="cbGaijiSize"></param>
    public void Import(NumericUpDown nuGaijiNo, ComboBox cbGaijiSize)
    {
      _no= (byte)nuGaijiNo.Value ;
      switch( cbGaijiSize.Text ){
      case _strSize30: _size= 0x30 ; break ;
      case _strSize31: _size= 0x31 ; break ;
      case _strSize32: _size= 0x32 ; break ;
      case _strSize33: _size= 0x33 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Oo^f[^ƂĕKvȃoCgԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
    /// </summary>
    /// <returns></returns>
    public uint GetNecessaryBytes()
    {
      uint rc= 0 ; // return code of this proc
      //
      switch( _size ){
      case 0x30: rc= V31Control.GetNecessaryBytes(24, 24 ) ; break ;
      case 0x31: rc= V31Control.GetNecessaryBytes(16, 16 ) ; break ;
      case 0x32: rc= V31Control.GetNecessaryBytes(12, 24 ) ; break ;
      case 0x33: rc= V31Control.GetNecessaryBytes( 8, 16 ) ; break ;
      }
      return rc ;
    }
  }
  # endregion

  # region C[Wf[^o^R}hp[^
  ///====================================================================================================
  /// <summary>
  /// sDC[Wf[^o^R}hp[^NXt
  /// ύX
  ///   2006/10/26 ( kw ) 
  ///   2006/11/10 ( kw ) C[Wo^f[^t@Cpf[^o̒ǉ
  /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
  /// @2009/07/13 ( kw ) C[W̍ől320ɕύX
  /// </summary>
  public class RegisterImage: ICloneable
  {
    const ushort _maxAddress= 0xFFFE ;
    const ushort _minAddress= 0 ;
    const string _defFileName= "Sanwa.bmp" ;
    const ushort _defAddress = 300 ;
    //
    ushort _address= _defAddress ;
    ushort _width= _minWidth ;
    ushort _height= _minHeight ;
    string _fileName= _defFileName ;
    //
    public const ushort _minWidth= 1 ;
    public const ushort _maxWidth= 320 ;
    public const ushort _minHeight= 1 ;
    public const ushort _maxHeight= 576 ;
    //
    public ushort Address { get { return _address ; } set { _address = value ; } }
    public ushort Width   { get { return _width   ; } set { _width   = value ; } }
    public ushort Height  { get { return _height  ; } set { _height  = value ; } }
    public string FileName{ get { return _fileName; } set { _fileName= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="nuImageAddress"></param>
    /// <param name="nuImageWidth"></param>
    /// <param name="nuImageHeight"></param>
    public static void SetControls(NumericUpDown nuImageAddress, NumericUpDown nuImageWidth, NumericUpDown nuImageHeight)
    {
      nuImageAddress.Maximum= _maxAddress ;
      nuImageAddress.Minimum= _minAddress ;
      nuImageWidth  .Maximum= _maxWidth ;
      nuImageWidth  .Minimum= _minWidth ;
      nuImageHeight .Maximum= _maxHeight ;
      nuImageHeight .Minimum= _minHeight ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hp[^̕\Ԃ 
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Address=0x{0:X4},Width={1},Height={2}", _address, _width, _height ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ; 
        else if(obj is RegisterImage ){
          RegisterImage r= (RegisterImage)obj ;
          rc= (r._address == _address  )
            &&(r._width   == _width    )
            &&(r._height  == _height   )
            &&(r._fileName== _fileName ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) f[^t@C̓]Lǉ
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      RegisterImage rc= new RegisterImage() ;
      rc._address = _address;
      rc._width   = _width  ;
      rc._height  = _height ;
      rc._fileName= _fileName ;
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^o^R}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="nuImageAddress"></param>
    /// <param name="nuImageWidth"></param>
    /// <param name="nuImageHeight"></param>
    public void Export(NumericUpDown nuImageAddress, NumericUpDown nuImageWidth, NumericUpDown nuImageHeight)
    {
      nuImageAddress.Value= _address ;
      nuImageWidth  .Value= _width ;
      nuImageHeight .Value= _height ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒC[Wf[^o^R}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="nuImageAddress"></param>
    /// <param name="nuImageWidth"></param>
    /// <param name="nuImageHeight"></param>
    public void Import(NumericUpDown nuImageAddress, NumericUpDown nuImageWidth, NumericUpDown nuImageHeight)
    {
      _address= (ushort)nuImageAddress.Value ;
      _width  = (ushort)nuImageWidth  .Value ;
      _height = (ushort)nuImageHeight .Value ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wo^ɕKvȃoCgԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// @2009/06/17 ( kw ) USBRg[ǉɂp[^
    /// </summary>
    /// <returns></returns>
    public uint GetNecessaryBytes()
    {
      return V31Control.GetNecessaryBytes(_width, _height ) ;
    }
  }
  # endregion

  # region 󎚐ݒR}hp[^
  ///===================================================================================================
  /// <summary>
  /// sD󎚐ݒR}hp[^NXt
  /// ύX
  ///   2006/10/26 ( kw ) 
  ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
  /// </summary>
  public class PrintSetting: ICloneable
  {
    const string _strCard30= "Cg     FB-661M" ;
    const string _strCard32= "CRJ[h     TRCGAACS/CH" ;
    const string _strCard33= "XOT[}   SNT-231-N1-T2" ;
    const string _strCard34= "PPOT[} SNT-220-T3" ;
    const string _strCard37= "CRCg   TRCG99SS/SH" ; 
    const string _strCard38= "CRCg   CR-631FB" ; 
    const string _strCard39= "J[h" ;
    const string _strCard3A= "qdcJ[h     KSNB-5360/5376" ; 
    const string _strCard3B= "CRCg   TRCGB3BSB" ;

    const string _strMode30= "{" ;
    const string _strMode31= "dˏ" ;
    const string _strAlign30= "WW" ;
    const string _strAlign33= "]W" ;
    const string _strAlign34= "E]W" ;
    const string _strFont30= "WtHg" ;
    const string _strFont31= "tHg" ;

    byte _card= 0x30 ;
    byte _mode= 0x30 ;
    byte _align= 0x30 ;
    byte _font= 0x30 ;

    public byte Card  { get { return _card  ; } set { _card= value  ; } }
    public byte Mode  { get { return _mode  ; } set { _mode= value  ; } }
    public byte Align { get { return _align ; } set { _align= value ; } } 
    public byte Font  { get { return _font  ; } set { _font = value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚐ݒR}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
    /// </summary>
    /// <param name="cbPrintSettingCard"></param>
    /// <param name="cbPrintSettingMode"></param>
    /// <param name="cbPrintSettingAlign"></param>
    /// <param name="cbPrintSettingFont"></param>
    public static void SetControls(ComboBox cbPrintSettingCard, ComboBox cbPrintSettingMode, ComboBox cbPrintSettingAlign, ComboBox cbPrintSettingFont)
    {
      cbPrintSettingCard .Items.AddRange(new object[]{_strCard30, _strCard32, _strCard33, _strCard34, _strCard37, _strCard38, _strCard39, _strCard3A, _strCard3B } ) ;
      cbPrintSettingMode .Items.AddRange(new object[]{_strMode30, _strMode31 } ) ;
      cbPrintSettingAlign.Items.AddRange(new object[]{ _strAlign30, _strAlign33, _strAlign34 } ) ;
      cbPrintSettingFont .Items.AddRange(new object[]{ _strFont30, _strFont31 } ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚐ݒR}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Card=0x{0:X2},Mode=0x{1:X2},Align=0x{2:X2},Font=0x{3:X2}", _card, _mode, _align, _font ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚐ݒR}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // retun code of this proc
      ///
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is PrintSetting ){
          PrintSetting r= (PrintSetting)obj ;
          rc= (r._card == _card  )
            &&(r._mode == _mode  )
            &&(r._align== _align )
            &&(r._font == _font  ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚐ݒR}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      PrintSetting r= new PrintSetting() ;
      r._card = _card  ;
      r._mode = _mode  ;
      r._align= _align ;
      r._font = _font  ;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚐ݒR}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
    /// </summary>
    /// <param name="cbPrintSettingCard"></param>
    /// <param name="cbPrintSettingMode"></param>
    /// <param name="cbPrintSettingAlign"></param>
    /// <param name="cbPrintSettingFont"></param>
    public void Export(ComboBox cbPrintSettingCard, ComboBox cbPrintSettingMode, ComboBox cbPrintSettingAlign, ComboBox cbPrintSettingFont)
    {
      switch( _card ){
      case 0x30: cbPrintSettingCard.Text= _strCard30 ; break ;
      case 0x32: cbPrintSettingCard.Text= _strCard32 ; break ;
      case 0x33: cbPrintSettingCard.Text= _strCard33 ; break ;
      case 0x34: cbPrintSettingCard.Text= _strCard34 ; break ;
      case 0x37: cbPrintSettingCard.Text= _strCard37 ; break ;
      case 0x38: cbPrintSettingCard.Text= _strCard38 ; break ;
      case 0x39: cbPrintSettingCard.Text= _strCard39 ; break ;
      case 0x3A: cbPrintSettingCard.Text= _strCard3A ; break ;
      case 0x3B: cbPrintSettingCard.Text= _strCard3B ; break ;
      }
      switch( _mode ){
      case 0x30: cbPrintSettingMode.Text= _strMode30 ; break ;
      case 0x31: cbPrintSettingMode.Text= _strMode31 ; break ;
      }
      switch( _align ){
      case 0x30: cbPrintSettingAlign.Text= _strAlign30 ; break ;
      case 0x33: cbPrintSettingAlign.Text= _strAlign33 ; break ;
      case 0x34: cbPrintSettingAlign.Text= _strAlign34 ; break ;
      }
      switch( _font ){
      case 0x30: cbPrintSettingFont.Text= _strFont30 ; break ;
      case 0x31: cbPrintSettingFont.Text= _strFont31 ; break ;
      }
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒ󎚐ݒR}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
    /// </summary>
    /// <param name="cbPrintSettingCard"></param>
    /// <param name="cbPrintSettingMode"></param>
    /// <param name="cbPrintSettingAlign"></param>
    /// <param name="cbPrintSettingFont"></param>
    public void Import(ComboBox cbPrintSettingCard, ComboBox cbPrintSettingMode, ComboBox cbPrintSettingAlign, ComboBox cbPrintSettingFont)
    {
      switch( cbPrintSettingCard.Text ){
      case _strCard30: _card= 0x30 ; break ; 
      case _strCard32: _card= 0x32 ; break ; 
      case _strCard33: _card= 0x33 ; break ; 
      case _strCard34: _card= 0x34 ; break ; 
      case _strCard37: _card= 0x37 ; break ; 
      case _strCard38: _card= 0x38 ; break ; 
      case _strCard39: _card= 0x39 ; break ; 
      case _strCard3A: _card= 0x3A ; break ; 
      case _strCard3B: _card= 0x3B ; break ; 
      }
      switch( cbPrintSettingMode.Text ){
      case _strMode30: _mode= 0x30 ; break ;
      case _strMode31: _mode= 0x31 ; break ;
      }
      switch( cbPrintSettingAlign.Text ){
      case _strAlign30: _align= 0x30 ; break ;
      case _strAlign33: _align= 0x33 ; break ;
      case _strAlign34: _align= 0x34 ; break ;
      }
      switch( cbPrintSettingFont.Text ){
      case _strFont30: _font= 0x30 ; break ;
      case _strFont31: _font= 0x31 ; break ;
      }
    }
  }
  # endregion

  # region C[Wf[^󎚃R}hp[^
  ///===================================================================================================
  /// <summary>
  /// sDC[Wf[^󎚃R}hp[^NXt
  /// ύX
  ///   2006/10/26 ( kw ) 
  ///   2006/11/10 ( kw ) C[Wf[^󎚃f[^pf[^o̒ǉ
  ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
  /// @2009/09/02 ( kw ) w󎚈ʒu̍ől311319ɕύX
  /// </summary>
  public class PrintImage: ICloneable
  {
    const string _strMode30= "WJ{" ;
    const string _strMode31= "WJ" ;
    const string _strMode32= "WJ{󎚁{ro" ;
    const string _strClear30= "󎚃obt@NA" ;
    const string _strClear31= "󎚃obt@NAȂ" ;
    const ushort _minX     =   0;
    const ushort _maxX     = 319;
    const ushort _minY     =   0;
    const ushort _maxY     = 575;
    const ushort _minAddress= 0x0000 ;
    const ushort _maxAddress= 0xFFFE ;
    const string _defFileName= "Sanwa.bmp" ;
    const byte _defMode= 0x32 ; // WJ{󎚁{ro
    const ushort _defAddress= 300 ;

    
    byte _mode= _defMode ;
    byte _clear= 0x30 ;
    ushort _width= _minWidth ;
    ushort _height= _minHeight ;
    ushort _x= _minX ;
    ushort _y= _minY ;
    ushort _address= _defAddress;
    bool   _byAddress= false ;
    string _fileName= _defFileName ;
    //
    public const ushort _minWidth =   1;
    public const ushort _maxWidth = 320;
    public const ushort _minHeight=   1;
    public const ushort _maxHeight= 576;
    //
    public byte   Mode      { get { return _mode     ; } set { _mode     = value ; } }
    public byte   Clear     { get { return _clear    ; } set { _clear    = value ; } }
    public ushort Width     { get { return _width    ; } set { _width    = value ; } }
    public ushort Height    { get { return _height   ; } set { _height   = value ; } }
    public ushort X         { get { return _x        ; } set { _x        = value ; } }
    public ushort Y         { get { return _y        ; } set { _y        = value ; } }
    public ushort Address   { get { return _address  ; } set { _address  = value ; } }
    public bool   ByAddress { get { return _byAddress; } set { _byAddress= value ; } }
    public string FileName  { get { return _fileName ; } set { _fileName = value ; } } 
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
    /// </summary>
    /// <param name="cbPrintImageMode"></param>
    /// <param name="cbPrintImageClear"></param>
    /// <param name="nuPrintImageWidth"></param>
    /// <param name="nuPrintImageHeight"></param>
    /// <param name="nuPrintImageX"></param>
    /// <param name="nuPrintImageY"></param>
    /// <param name="nuPrintImageAddress"></param>
    /// <param name="cbPrintImageByAddress"></param>
    public static void SetControls(ComboBox cbPrintImageMode, ComboBox cbPrintImageClear, NumericUpDown nuPrintImageWidth, NumericUpDown nuPrintImageHeight, NumericUpDown nuPrintImageX, NumericUpDown nuPrintImageY, NumericUpDown nuPrintImageAddress, CheckBox cbPrintImageByAddress)
    {
      cbPrintImageMode.Items.AddRange(new object[]{_strMode30, _strMode31, _strMode32 } ) ;
      cbPrintImageClear.Items.AddRange(new object[]{_strClear30, _strClear31 } ) ;
      nuPrintImageWidth.Maximum= _maxWidth ;
      nuPrintImageWidth.Minimum= _minWidth ;
      nuPrintImageHeight.Maximum= _maxHeight ;
      nuPrintImageHeight.Minimum= _minHeight ;
      nuPrintImageX.Maximum= _maxX ;
      nuPrintImageX.Minimum= _minX ;
      nuPrintImageY.Maximum= _maxY ;
      nuPrintImageY.Minimum= _minY ;
      nuPrintImageAddress.Maximum= _maxAddress ;
      nuPrintImageAddress.Minimum= _minAddress ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      string str ;
      if(_byAddress ){
      str= string.Format("Mode=0x{0:X2},Clear=0x{1:X2},Width={2},Height={3},X={4},Y={5},Address=0x{6:X4}"
        ,_mode, _clear, _width, _height, _x, _y, _address 
      ) ;
      }else {
      str= string.Format("Mode=0x{0:X2},Clear=0x{1:X2},Width={2},Height={3},X={4},Y={5}"
        ,_mode, _clear, _width, _height, _x, _y 
      ) ;
      }
      return str ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is PrintImage ){
          PrintImage r= (PrintImage)obj ;
          rc= (r._mode     == _mode     )
            &&(r._clear    == _clear    )
            &&(r._width    == _width    )
            &&(r._height   == _height   )
            &&(r._x        == _x        )
            &&(r._y        == _y        )
            &&(r._address  == _address  )
            &&(r._byAddress== _byAddress)
            &&(r._fileName == _fileName ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) C[Wf[^󎚃t@C̓]Lǉ
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      PrintImage r= new PrintImage() ;
      r._mode     = _mode ;
      r._clear    = _clear ;
      r._width    = _width ;
      r._height   = _height ;
      r._x        = _x ;
      r._y        = _y ;
      r._address  = _address ;
      r._byAddress= _byAddress ;
      r._fileName = _fileName  ;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// C[Wf[^󎚃R}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
    /// </summary>
    /// <param name="cbPrintImageMode"></param>
    /// <param name="cbPrintImageClear"></param>
    /// <param name="nuPrintImageWidth"></param>
    /// <param name="nuPrintImageHeight"></param>
    /// <param name="nuPrintImageX"></param>
    /// <param name="nuPrintImageY"></param>
    /// <param name="nuPrintImageAddress"></param>
    /// <param name="cbPrintImageByAddress"></param>
    public void Export(ComboBox cbPrintImageMode, ComboBox cbPrintImageClear, NumericUpDown nuPrintImageWidth, NumericUpDown nuPrintImageHeight, NumericUpDown nuPrintImageX, NumericUpDown nuPrintImageY, NumericUpDown nuPrintImageAddress, CheckBox cbPrintImageByAddress)
    {
      switch( _mode ){
      case 0x30: cbPrintImageMode.Text= _strMode30 ; break ;
      case 0x31: cbPrintImageMode.Text= _strMode31 ; break ;
      case 0x32: cbPrintImageMode.Text= _strMode32 ; break ;
      }
      switch( _clear ){
      case 0x30: cbPrintImageClear.Text= _strClear30; break ;
      case 0x31: cbPrintImageClear.Text= _strClear31; break ;
      }
      nuPrintImageWidth    .Value  = _width ;
      nuPrintImageHeight   .Value  = _height ;
      nuPrintImageX        .Value  = _x ;
      nuPrintImageY        .Value  = _y ;
      nuPrintImageAddress  .Value  = _address   ;
      cbPrintImageByAddress.Checked= _byAddress ;
      nuPrintImageAddress  .Enabled= _byAddress ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒC[Wf[^󎚃R}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2009/06/24 ( kw ) qa̎dlɂ킹ăJ[hʌ
    /// </summary>
    /// <param name="cbPrintImageMode"></param>
    /// <param name="cbPrintImageClear"></param>
    /// <param name="nuPrintImageWidth"></param>
    /// <param name="nuPrintImageHeight"></param>
    /// <param name="nuPrintImageX"></param>
    /// <param name="nuPrintImageY"></param>
    /// <param name="nuPrintImageAddress"></param>
    /// <param name="cbPrintImageByAddress"></param>
    public void Import(ComboBox cbPrintImageMode, ComboBox cbPrintImageClear, NumericUpDown nuPrintImageWidth, NumericUpDown nuPrintImageHeight, NumericUpDown nuPrintImageX, NumericUpDown nuPrintImageY, NumericUpDown nuPrintImageAddress, CheckBox cbPrintImageByAddress)
    {
      switch( cbPrintImageMode.Text ){
      case _strMode30: _mode= 0x30 ; break ;
      case _strMode31: _mode= 0x31 ; break ;
      case _strMode32: _mode= 0x32 ; break ;
      }
      switch( cbPrintImageClear.Text ){
      case _strClear30: _clear= 0x30 ; break ;
      case _strClear31: _clear= 0x31 ; break ;
      }
      _width  = (ushort)nuPrintImageWidth  .Value ;
      _height = (ushort)nuPrintImageHeight .Value ;
      _x      = (ushort)nuPrintImageX      .Value ;
      _y      = (ushort)nuPrintImageY      .Value ;
      _address= (ushort)nuPrintImageAddress.Value ;
      _byAddress= cbPrintImageByAddress.Checked ;
    }
  }
  # endregion

  # region 󎚃R}hp[^NX
  ///===================================================================================================
  /// <summary>
  /// sD󎚃R}hp[^NXt
  /// ύX
  ///   2006/10/26 ( kw ) 
  ///   2006/11/10 ( kw ) 󎚃R}hf[^t@Cpf[^oǉ
  /// </summary>
  public class PrintString: ICloneable
  {
    const byte _minLine= 0x00 ;
    const byte _maxLine= 0x14 ;
    const string _strMode30= "WJ{" ;
    const string _strMode31= "WJ" ;
    const string _strMode32= "WJ{󎚁{ro" ;
    const string _strClear30= "󎚃obt@NA" ;
    const string _strClear31= "󎚃obt@NAȂ" ;
    const string _defFileName= "PrintString.xml" ; 
    const byte _defMode= 0x32 ; // WJ{󎚁{ro

    byte _mode= _defMode ;
    byte _clear= 0x30 ;
    byte _line= 0x00 ;
    string _fileName= _defFileName ;
    
    public byte   Mode    { get { return _mode    ; } set { _mode    = value ; } }
    public byte   Clear   { get { return _clear   ; } set { _clear   = value ; } }
    public byte   Line    { get { return _line    ; } set { _line    = value ; } }
    public string FileName{ get { return _fileName; } set { _fileName= value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="cbPrinttringMode"></param>
    /// <param name="cbPrintStringClear"></param>
    /// <param name="nuPrintStringLine"></param>
    public static void SetControls(ComboBox cbPrinttringMode, ComboBox cbPrintStringClear, NumericUpDown nuPrintStringLine)
    {
      cbPrinttringMode.Items.AddRange( new object[]{ _strMode30, _strMode31, _strMode32 } ) ;
      cbPrintStringClear.Items.AddRange( new object[] { _strClear30, _strClear31 } ) ;
      nuPrintStringLine.Maximum= _maxLine ;
      nuPrintStringLine.Minimum= _minLine ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Mode=0x{0:X2},Clear=0x{1:X2},Line=0x{2:X2}", _mode, _clear, _line ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= this ){
        if(obj== this ) rc= true ;
        else if(obj is PrintString ){
          PrintString r= (PrintString)obj ;
          rc= (r._mode    == _mode     )
            &&(r._clear   == _clear    )
            &&(r._line    == _line     )
            &&(r._fileName== _fileName ) ;
        }
      }
      return rc ;

    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    ///   2006/11/10 ( kw ) 󎚃f[^t@C̓]Lǉ
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      PrintString r=new PrintString() ;
      r._mode    = _mode    ; 
      r._clear   = _clear   ;
      r._line    = _line    ;
      r._fileName= _fileName;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 󎚃R}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="cbPrintStringMode"></param>
    /// <param name="cbPrintStringClear"></param>
    /// <param name="nuPrintStringLine"></param>
    public void Export(ComboBox cbPrintStringMode, ComboBox cbPrintStringClear, NumericUpDown nuPrintStringLine)
    {
      switch( _mode ){
      case 0x30: cbPrintStringMode.Text= _strMode30 ; break ;
      case 0x31: cbPrintStringMode.Text= _strMode31 ; break ;
      case 0x32: cbPrintStringMode.Text= _strMode32 ; break ;
      }
      switch( _clear ){
      case 0x30: cbPrintStringClear.Text= _strClear30 ; break ;
      case 0x31: cbPrintStringClear.Text= _strClear31 ; break ;
      }
      nuPrintStringLine.Value= _line ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒ𕶎󎚃R}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="cbPrintStringMode"></param>
    /// <param name="cbPrintStringClear"></param>
    /// <param name="nuPrintStringLine"></param>
    public void Import(ComboBox cbPrintStringMode, ComboBox cbPrintStringClear, NumericUpDown nuPrintStringLine)
    {
      switch( cbPrintStringMode.Text ){
      case _strMode30: _mode= 0x30 ; break ;
      case _strMode31: _mode= 0x31 ; break ;
      case _strMode32: _mode= 0x32 ; break ;
      }
      switch( cbPrintStringClear.Text ){
      case _strClear30: _clear= 0x30 ; break ;
      case _strClear31: _clear= 0x31 ; break ;
      }
      _line= (byte)nuPrintStringLine.Value ;
    }
  }
  # endregion

  # region o[R[h󎚃R}hp[^
  ///===================================================================================================
  /// <summary>
  /// sDo[R[h󎚃R}hp[^NXt
  /// ύX
  ///   2006/10/26 ( kw ) 
  /// </summary>
  public class PrintBarcode: ICloneable
  {
    const string _strMode30= "WJ{" ;
    const string _strMode31= "WJ" ;
    const string _strMode32= "WJ{󎚁{ro" ;
    const string _strClear30= "󎚃obt@NA" ;
    const string _strClear31= "󎚃obt@NAȂ" ;
    const string _strKind30= "JANW" ;
    const string _strKind31= "JANZk" ;
    const string _strKind32= "NW-7" ;
    const string _strKind33= "CODE39" ;
    const string _strTip30= "" ;
    const string _strTip31= "Ȃ" ;
    const string _strWidth30= "Qhbg" ;
    const string _strWidth31= "Rhbg" ;
    //
    const byte _minHeight= 1 ;
    const byte _maxHeight= 0x30 ;
    const byte _minX= 0 ;
    const byte _maxX= 0x1E ;
    const byte _minY= 0 ;
    const byte _maxY= 0x40 ;
    //
    byte _mode= 0x30 ;
    byte _clear= 0x30 ;
    byte _kind= 0x30 ;
    byte _tip= 0x30 ;
    byte _width= 0x30 ;
    byte _height= _minHeight ;
    byte _x= _minX ;
    byte _y= _minY ;
    string _data="" ;
    //
    public byte   Mode  { get { return _mode  ; } set { _mode  = value ; } }
    public byte   Clear { get { return _clear ; } set { _clear = value ; } }
    public byte   Kind  { get { return _kind  ; } set { _kind  = value ; } }
    public byte   Tip   { get { return _tip   ; } set { _tip   = value ; } }
    public byte   Width { get { return _width ; } set { _width = value ; } }
    public byte   Height{ get { return _height; } set { _height= value ; } }
    public byte   X     { get { return _x     ; } set { _x     = value ; } }
    public byte   Y     { get { return _y     ; } set { _y     = value ; } }
    public string Data  { get { return _data  ; } set { _data  = value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// o[R[h󎚃R}hp[^ɊւRg[̏ݒs
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <param name="cbPrintBarcodeMode"></param>
    /// <param name="cbPrintBarcodeClear"></param>
    /// <param name="cbPrintBarcodeKind"></param>
    /// <param name="cbPrintBarcodeTip"></param>
    /// <param name="cbPrintBarcodeWidth"></param>
    /// <param name="nuPrintBarcodeHeight"></param>
    /// <param name="nuPrintBarcodeX"></param>
    /// <param name="nuPrintBarcodeY"></param>
    public static void SetControls(ComboBox cbPrintBarcodeMode, ComboBox cbPrintBarcodeClear, ComboBox cbPrintBarcodeKind, ComboBox cbPrintBarcodeTip, ComboBox cbPrintBarcodeWidth, NumericUpDown nuPrintBarcodeHeight, NumericUpDown nuPrintBarcodeX, NumericUpDown nuPrintBarcodeY)
    {
      cbPrintBarcodeMode.Items.AddRange( new object[]{ _strMode30, _strMode31, _strMode32 } ) ;
      cbPrintBarcodeClear.Items.AddRange( new object[]{ _strClear30, _strClear31 } ) ;
      cbPrintBarcodeKind.Items.AddRange(new object[]{ _strKind30, _strKind31, _strKind32, _strKind33 } ) ;
      cbPrintBarcodeTip.Items.AddRange(new object[]{ _strTip30, _strTip31 } ) ;
      cbPrintBarcodeWidth.Items.AddRange( new object[] {_strWidth30, _strWidth31 } ) ;
      nuPrintBarcodeHeight.Maximum= _maxHeight ;
      nuPrintBarcodeHeight.Minimum= _minHeight ;
      nuPrintBarcodeX.Maximum= _maxX ;
      nuPrintBarcodeX.Minimum= _minX ;
      nuPrintBarcodeY.Maximum= _maxY ;
      nuPrintBarcodeY.Minimum= _minY ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// o[R[h󎚃R}hp[^̕\Ԃ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override string ToString()
    {
      return string.Format("Mode=0x{0:X2},Clear=0x{1:X2},Kind=0x{2:X2},Tip=0x{3:X2},Width=0x{4:X2},Height={5},X={6},Y={7},Data={8}", _mode, _clear, _kind, _tip, _width, _height, _x, _y, _data ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// o[R[h󎚃R}hp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is PrintBarcode ){
          PrintBarcode r= (PrintBarcode)obj ;
          rc= (r._mode  == _mode   )
            &&(r._clear == _clear  )
            &&(r._kind  == _kind   )
            &&(r._tip   == _tip    )
            &&(r._width == _width  )
            &&(r._height== _height )
            &&(r._x     == _x      )
            &&(r._y     == _y      )
            &&(r._data  == _data   ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// o[R[h󎚃R}hp[^̃Rs[CX^XԂ
    /// ύX
    ///   2006/10/26 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      PrintBarcode r= new PrintBarcode() ;
      r._mode  = _mode ;
      r._clear = _clear;
      r._kind  = _kind ;
      r._tip   = _tip  ;
      r._width = _width ;
      r._height= _height ;
      r._x     = _x ; 
      r._y     = _y ;
      r._data  = _data ;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// o[R[h󎚃R}hp[^̃f[^olRg[ɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="cbPrintBarcodeMode"></param>
    /// <param name="cbPrintBarcodeClear"></param>
    /// <param name="cbPrintBarcodeKind"></param>
    /// <param name="cbPrintBarcodeTip"></param>
    /// <param name="cbPrintBarcodeWidth"></param>
    /// <param name="nuPrintBarcodeHeight"></param>
    /// <param name="nuPrintBarcodeX"></param>
    /// <param name="nuPrintBarcodeY"></param>
    /// <param name="edPrintBarcodeData"></param>
    public void Export(ComboBox cbPrintBarcodeMode, ComboBox cbPrintBarcodeClear, ComboBox cbPrintBarcodeKind, ComboBox cbPrintBarcodeTip, ComboBox cbPrintBarcodeWidth, NumericUpDown nuPrintBarcodeHeight, NumericUpDown nuPrintBarcodeX, NumericUpDown nuPrintBarcodeY, TextBox edPrintBarcodeData)
    {
      switch( _mode ){
      case 0x30: cbPrintBarcodeMode.Text= _strMode30; break ;
      case 0x31: cbPrintBarcodeMode.Text= _strMode31; break ;
      case 0x32: cbPrintBarcodeMode.Text= _strMode32; break ;
      }
      switch( _clear ){
      case 0x30: cbPrintBarcodeClear.Text= _strClear30; break ;
      case 0x31: cbPrintBarcodeClear.Text= _strClear31; break ;
      }
      switch( _kind ){
      case 0x30: cbPrintBarcodeKind.Text= _strKind30; break ;
      case 0x31: cbPrintBarcodeKind.Text= _strKind31; break ;
      case 0x32: cbPrintBarcodeKind.Text= _strKind32; break ;
      case 0x33: cbPrintBarcodeKind.Text= _strKind33; break ;
      }
      switch( _tip ){
      case 0x30: cbPrintBarcodeTip.Text= _strTip30; break ;
      case 0x31: cbPrintBarcodeTip.Text= _strTip31; break ;
      }
      switch( _width ){
      case 0x30: cbPrintBarcodeWidth.Text= _strWidth30; break ;
      case 0x31: cbPrintBarcodeWidth.Text= _strWidth31; break ;
      }
      nuPrintBarcodeHeight.Value= _height ;
      nuPrintBarcodeX.Value= _x ;
      nuPrintBarcodeY.Value= _y ;
      edPrintBarcodeData.Text= _data ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Rg[̐ݒo[R[h󎚃R}hp[^̃f[^oɔf
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <param name="cbPrintBarcodeMode"></param>
    /// <param name="cbPrintBarcodeClear"></param>
    /// <param name="cbPrintBarcodeKind"></param>
    /// <param name="cbPrintBarcodeTip"></param>
    /// <param name="cbPrintBarcodeWidth"></param>
    /// <param name="nuPrintBarcodeHeight"></param>
    /// <param name="nuPrintBarcodeX"></param>
    /// <param name="nuPrintBarcodeY"></param>
    /// <param name="edPrintBarcodeData"></param>
    public void Import(ComboBox cbPrintBarcodeMode, ComboBox cbPrintBarcodeClear, ComboBox cbPrintBarcodeKind, ComboBox cbPrintBarcodeTip, ComboBox cbPrintBarcodeWidth, NumericUpDown nuPrintBarcodeHeight, NumericUpDown nuPrintBarcodeX, NumericUpDown nuPrintBarcodeY, TextBox edPrintBarcodeData)
    {
      switch( cbPrintBarcodeMode.Text ){
      case _strMode30: _mode= 0x30 ; break ;
      case _strMode31: _mode= 0x31 ; break ;
      case _strMode32: _mode= 0x32 ; break ;
      }
      switch( cbPrintBarcodeClear.Text ){
      case _strClear30: _clear= 0x30; break ;
      case _strClear31: _clear= 0x31; break ;
      }
      switch( cbPrintBarcodeKind.Text ){
      case _strKind30: _kind= 0x30; break ;
      case _strKind31: _kind= 0x31; break ;
      case _strKind32: _kind= 0x32; break ;
      case _strKind33: _kind= 0x33; break ;
      }
      switch( cbPrintBarcodeTip.Text ){
      case _strTip30: _tip= 0x30; break ;
      case _strTip31: _tip= 0x31; break ;
      }
      switch( cbPrintBarcodeWidth.Text ){
      case _strWidth30: _width= 0x30 ; break ;
      case _strWidth31: _width= 0x31 ; break ;
      }
      _height= (byte)nuPrintBarcodeHeight.Value ;
      _x     = (byte)nuPrintBarcodeX.Value ;
      _y     = (byte)nuPrintBarcodeY.Value ;
      _data  = edPrintBarcodeData.Text ;

    }
  }
  # endregion






  # region AvP[Vf[^

  ///===================================================================================================
  /// <summary>
  /// sDAvP[Vf[^NXt
  /// ύX
  ///   2006/10/25 ( kw ) 
  /// </summary>
  public class AppData: ICloneable
  {
    public const string _strParityNone= "Ȃ" ;
    public const string _strParityEven= "" ;
    public const string _strParityOdd = "" ;
    public const string _strStopBitsOne= "1" ;
    public const string _strStopBitsTwo= "2" ;
    
    /// <summary>
    /// ݒt@C̊gqi.configj</summary>
    const string _configExt= ".config" ;
    /// <summary>
    /// Avݒt@C</summary>
    static string _configFile= null ;
    //
    int           _left         = 0 ;
    int           _top          = 0 ;
    CommPort      _commPort     = new CommPort     () ;
    Initialize    _initialize   = new Initialize   () ;
    Read          _read         = new Read         () ;
    Write         _write        = new Write        () ;
    RegisterGaiji _registerGaiji= new RegisterGaiji() ;
    RegisterImage _registerImage= new RegisterImage() ;
    PrintSetting  _printSetting = new PrintSetting () ;
    PrintImage    _printImage   = new PrintImage   () ;
    PrintString   _printString  = new PrintString  () ;
    PrintBarcode  _printBarcode = new PrintBarcode () ;
    
    public int Left   { get { return _left   ; } set { _left  = value ; } }
    public int Top    { get { return _top    ; } set { _top   = value ; } }
    public CommPort      CommPort      { get { return _commPort      ; } set { _commPort     = value ; } }
    public Initialize    Initialize    { get { return _initialize    ; } set { _initialize   = value ; } }
    public Read          Read          { get { return _read          ; } set { _read         = value ; } }
    public Write         Write         { get { return _write         ; } set { _write        = value ; } }
    public RegisterGaiji RegisterGaiji { get { return _registerGaiji ; } set { _registerGaiji= value ; } }
    public RegisterImage RegisterImage { get { return _registerImage ; } set { _registerImage= value ; } }
    public PrintSetting  PrintSetting  { get { return _printSetting  ; } set { _printSetting = value ; } }
    public PrintImage    PrintImage    { get { return _printImage    ; } set { _printImage   = value ; } }
    public PrintString   PrintString   { get { return _printString   ; } set { _printString  = value ; } }
    public PrintBarcode  PrintBarcode  { get { return _printBarcode  ; } set { _printBarcode = value ; } }
    ///*************************************************************************************************
    /// <summary>
    /// ÓIRXgN^
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    static AppData()
    {
      // AvP[Vf[^ptH_̌聕tH_̍쐬
      string dir= Path.Combine(
                      Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData )
                    ,  Application.CompanyName+ "\\"
                     + Application.ProductName
                  ) ; 
      Directory.CreateDirectory( dir ) ;
      //
      // AvP[Vf[^t@Č
      _configFile= Path.Combine(dir, Application.ProductName+ "_"+ Application.ProductVersion )+ _configExt ;
      Debug.WriteLine(_configFile ) ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// ʐMݒp[^̃nbVR[hԂ
    /// ύX
    ///   2006/10/27 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public override int GetHashCode()
    {
      return ToString().GetHashCode();
    }
    ///*************************************************************************************************
    /// <summary>
    /// rZs
    /// ύX
    ///   2006/11/10 ( kw ) 
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    public override bool Equals(object obj)
    {
      bool rc= false ; // return code of this proc
      //
      if(obj!= null ){
        if(obj== this ) rc= true ;
        else if(obj is AppData ){
          AppData r= (AppData)obj ;
          rc= (r._left== _left )
            &&(r._top == _top  )
            && r._commPort     .Equals( _commPort      )
            && r._initialize   .Equals( _initialize    )
            && r._read         .Equals( _read          )
            && r._write        .Equals( _write         )
            && r._registerGaiji.Equals( _registerGaiji )
            && r._registerImage.Equals( _registerImage )
            && r._printSetting .Equals( _printSetting  )
            && r._printImage   .Equals( _printImage    )
            && r._printString  .Equals( _printString   )
            && r._printBarcode .Equals( _printBarcode  ) ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// 
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public object Clone()
    {
      AppData r= new AppData() ;
      r._left         = _left ;
      r._top          = _top ;
      r._commPort     = (CommPort     )_commPort     .Clone() ;
      r._initialize   = (Initialize   )_initialize   .Clone() ;
      r._read         = (Read         )_read         .Clone() ;
      r._write        = (Write        )_write        .Clone() ;
      r._registerGaiji= (RegisterGaiji)_registerGaiji.Clone() ;
      r._registerImage= (RegisterImage)_registerImage.Clone() ;
      r._printSetting = (PrintSetting )_printSetting .Clone() ;
      r._printImage   = (PrintImage   )_printImage   .Clone() ;
      r._printString  = (PrintString  )_printString  .Clone() ;
      r._printBarcode = (PrintBarcode )_printBarcode .Clone() ;
      return r ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// fBXNAvf[^ǂݏo
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public bool Load()
    {
      bool rc= false ; // return code of this proc
      ///
      if(!File.Exists(_configFile ) ) rc= Save() ;
      else {
        XmlSerializer xs ;
        FileStream    fs= null ;
        try {
          xs= new XmlSerializer(typeof(AppData ) ) ;
          fs= new FileStream(_configFile, FileMode.Open ) ;
          AppData r= (AppData)xs.Deserialize(fs ) ;
          // ʃWIg
          _left         = r._left          ; // ʍʒu
          _top          = r._top           ; // ʍʒu
          _commPort     = r._commPort      ; // ʐMݒp[^
          _initialize   = r._initialize    ; // Initialize   ()p[^
          _read         = r._read          ; // Read         ()p[^
          _write        = r._write         ; // Write        ()p[^
          _registerGaiji= r._registerGaiji ; // RegisterGaiji()p[^
          _registerImage= r._registerImage ; // RegisterImage()p[^
          _printSetting = r._printSetting  ; // PrintSetting ()p[^
          _printImage   = r._printImage    ; // PrintImage   ()p[^
          _printString  = r._printString   ; // PrintString  ()p[^
          _printBarcode = r._printBarcode  ; // PrintBarcode ()p[^
          //Debug.WriteLine( r ) ;
          rc= true ;
        }
        catch(Exception ex ){
          Debug.WriteLine( ex ) ;
        }
        finally {
          if(fs!= null ) fs.Close() ;
        }
      }
      return rc ;
    }
    ///*************************************************************************************************
    /// <summary>
    /// Avf[^fBXNɕۑ
    /// ύX
    ///   2006/10/25 ( kw ) 
    /// </summary>
    /// <returns></returns>
    public bool Save()
    {
      bool rc= false ; // return code of this proc
      //
      XmlSerializer xs=null;
      FileStream    fs= null ;
      try {
        xs= new XmlSerializer(typeof(AppData ) ) ;
        fs= new FileStream(_configFile, FileMode.Create ) ;
        xs.Serialize(fs, this ) ;
        rc= true ;
      }
      catch(Exception ex ){
        Debug.WriteLine( ex ) ;
      }
      finally {
        if(fs!= null ) fs.Close() ;
      }
      return rc ;
    }
  }
  # endregion
}
